#!/bin/bash
isportalnode=`echo "$1" | grep portalnode`
if [ "$isportalnode" != "" ] ; then
  exit 1
fi
c=`echo $1 | sed s/[/]dev.doc.*//`
c=`echo $c | sed s/^.*[/]//`

# retrieve current change number from file
CHANGENUM_FILE=/home/scripts/include/changenum
CHANGENUM=`cat $CHANGENUM_FILE`
CHANGENUM=$[$CHANGENUM+1]

# replace NEW entries in changelog with number
perl -pi -e "s/^(.{10})[\t ]+NEW/\$num = $CHANGENUM+\$i++; print STDERR \$num,qq(\n); qq(\$1\t) . \$num/ge" $1 2>tmpchangenum
if [ -s tmpchangenum ] ; then
        echo "found NEW entries - updating $CHANGENUM_FILE"
        tail -1<tmpchangenum > $CHANGENUM_FILE
else
        echo "no NEW changes found in changelog"
fi

dir=`echo $1 | sed s/[^/]*$//`
cd $dir
cvs commit -m "@bogus auto-commit by dist.sh." CHANGELOG >/dev/null 2>&1
cd -

cp $1 $2/$c.CHANGELOG
