<?

define("XML_CASE_UPPER", 1);
define("XML_CASE_NONE", 0);
define("XML_CASE_LOWER", -1);

class XmlFileObject extends FileObject {

var $header;
var $struct;
var $lineEnd;
var $uppercase;

function XmlFileObject($file) {
parent::FileObject($file);
$this->header = "<xml version=\"1.0\">";
$this->struct = false;
$this->lineEnd = "\n";
$this->uppercase = XML_CASE_LOWER;
}

function isUppercase() {
return $this->uppercase;
}

function setUppercase($mode) {
$this->uppercase = $mode;
}

function getHeader() {
return $this->header;
}

function setHeader($val) {
$this->header = $val;
}

function getStruct() {
if (!is_array($this->struct)) {
$this->_parseFile($vals, $index);
$this->struct = $this->_generateStruct($vals, $i=0);
}
return $this->struct;
}

function &getRootNode() {
$struct = $this->getStruct();
list($el, $val) = each($struct["list"]);
$node =& new XmlNodeObject($val);
return $node;
}

function setStruct($struct) {
$this->struct = $struct;
$file = $this->getHeader().$this->lineEnd;
$file .= $this->_generateFile($struct);
$this->setContent($file);
}

/**
 *                                                                                                             
 *                      
 **/
function getXmlNodeObject($key, $isnumeric = false, $splitter = ".") {
$struct = $this->getStruct();
$keys = explode($splitter, $key);
$i = 0;
while ($i < count($keys) && is_array($struct)) {
$struct = $isnumeric?$struct["childlist"][$keys[$i++]]:
$struct["childs"][$keys[$i]][ereg("\[([0-9]+)\]$",$keys[$i++],$regs)?$regs[1]:0];
}
return new XmlNodeObject($struct);
}

function _parseFile(&$vals, &$index) {

$data = $this->getContent();

$xmlparser = xml_parser_create();
xml_parser_set_option($xmlparser, XML_OPTION_CASE_FOLDING, $this->uppercase==XML_CASE_UPPER?1:0);
xml_parser_set_option($xmlparser, XML_OPTION_SKIP_WHITE, 1);
xml_parse_into_struct($xmlparser, $data, $vals, $index);
xml_parser_free($xmlparser);
}

function _generateStruct(&$vals, &$i) {

//                                                                                               

$struct = array();

while ($i < count($vals)) {

$v =& $vals[$i++];

switch ($v["type"]) {
case "cdata":
case "complete":
$this->_addChildNode($struct, $v);
break;
case "open":
$this->_addChildNode($struct, $v, $this->_generateStruct($vals, $i));
break;
case "close";
break 2; //            
 }
}

return $struct;
}

function _addChildNode(&$struct, &$val, $childs = NULL) {

$node = array();

$node["type"] = $val["type"];
$node["level"] = $val["level"];

if (isset($val["tag"])) {
$name = ($this->uppercase == XML_CASE_LOWER)?strtolower($val["tag"]):$val["tag"];
$node["name"] = $name;
}

if (isset($val["value"])) $node["value"] = $val["value"];
if (isset($val["attributes"])) $node["attributes"] = $this->_fetchAttributes($val["attributes"]);
if (is_array($childs)) { $node["childs"] = $childs["childs"]; $node["childlist"] = $childs["childlist"]; }

//                                                                                   
 $struct["childs"][$name][] = $node;
$struct["childlist"][] = $node;
}

function _fetchAttributes($attributes) {
$attrs = array();
if (is_array($attributes)) {
foreach ($attributes as $name=>$val) {
if ($this->uppercase == XML_LOWER_CASE) $name = strtolower($name);
if (preg_match("/^([\"'])(.*)\\1$/", $val, $regs)) $val = $regs[2];
$attrs[$name] = $val;
}
} else {
$attrs = $attributes;
}
return $attrs;
}

function _generateFile($struct) {

}



}

class XmlNodeObject extends BaseObject {

var $struct;

function XmlNodeObject($struct) {
parent::BaseObject();
$this->struct = $struct;
}

function getName() {
return $this->struct["name"];
}

function getAttribute($name) {
return $this->struct["attributes"][$name];
}

function getAttributes() {
return $this->struct["attributes"];
}

function getValue($mergeTags = true) {
///                                                 
 
return $this->struct["value"];
}

function countChilds($name=false) {
return $name?count($this->struct["childs"][$name]):$this->struct["childlist"];
}

function &getChilds($name=false) {
$el = $name?$this->struct["childs"][$name]:$this->struct["childlist"];
if (!is_array($el)) return array();
$items = array();
foreach ($el as $key=>$struct) {
$items[$key] = new XmlNodeObject($struct);
}
return $items;
}

function &getChild($id) {
return new XmlNodeObject($this->struct["childlist"][$id]);
}

function getChildByName($name, $id = 0) {
return new XmlNodeObject($this->struct["childs"][$name][$id]);
}

function getStruct($recursive = true) {

}

/**
  *        
  **/
function isValidNode($structNode) {

}

}

?>
