<?php

/**
 * 
 *
 *                                                                                     
 *                 
 **/
class IntegrationDatasource extends AbstractDatasource
{
var $m_firstStep;
var $m_params = null;
var $m_list = array();

function IntegrationDatasource() {
$this->m_params = new ParamHelper();
}

function getTypeName()
{
return i18n( "Integration Datasource" );
}

function getType()
{
return DATASOURCE_INTEGRATION;
}

function setFirstStep( $stepNr )
{
$this->m_firstStep = $stepNr;
}

function updateStep( &$wizard, $stepNr, &$form )
{
$step =& $wizard->getStep( $stepNr );
$vac =& $step->getComponent( "vals" );
$wizard->setButtonsVisibility( $vac->buttonsVisible() ); 
}

function createStep( &$wizard, $stepNr, &$form )
{
node_class( "textcomponent" );
$comp = new TextComponent(i18n("HTTP-Variable"), true, $this->m_params->getParam( "httpvar", "" ) );
$form->addComponent( "httpvar", $comp  );
$wizard->lastStep();
}

function done( &$wizard )
{
$step =& $wizard->getStep( $this->m_firstStep );
/*                       */
$v =& $step->getComponent( "httpvar" );
$this->m_params->setParam( "httpvar", $v->getText() );
}

function load( $list, &$params )
{
//                                                                       
if ( $params->getParam( "httpvar", NULL ) === NULL )
$params->setParam( "httpvar", $list[0]["value"] );
unset( $list[0] );
$this->m_list = array();
foreach ( $list as $val ) {
$this->m_list[$val["value"]] = $val;
}
$this->m_params =& $params;
}

function &getParams()
{
return $this->m_params;
}

function needsSync() {
return true;
}

/**
  *                                                             
  *                                                                               
  *                                                                               
  *                                                                                             
  *
  **/

function getAllValues()
{
return $this->m_list; 
}

function export()
{
$ret = array();
$httpVar = $this->m_params->getParam( "httpvar", "" );
if ( !$httpVar ) return array();

global ${$httpVar};
$arr = split("\\^", ${$httpVar});

if ( is_array($arr) ) {
foreach ( $arr as $var ) {
$val = split(":", $var);
if ( count($val) == 2 ) {
$ret[$val[1]] = array("key"=>$val[0], "value"=>$val[1]);
} else if ( strlen($var)>0 ) {
$ret[$var] = array("key"=>$var, "value"=>$var);
}

}
}
return $ret; //                                                                 
}

function exportValues()
{
return $this->m_list;
}


function exportIds()
{
$ret = array();
$httpVar = $this->m_params->getParam( "httpvar", "" );
if ( !$httpVar ) return array();
global ${$httpVar};
$arr = split("\\^", ${$httpVar});

if ( is_array($arr) ) {
foreach ( $arr as $var ) {
$val = split(":", $var);
if ( count($val) == 2 ) {
$ret[] = $val[0]; 
} else if ( strlen($var)>0 ) {
$ret[] = $var; 
}

}
}
return $ret; //                                                                 
}

function getEventDependencies()
{
/*               
               
                                                                
    */
}

function translate( $ids, $template )
{
$prefix = "ds";
$prefixLength = strlen( $prefix );
$offset = 0;
$parts = array();

if ( strlen( trim( $template ) ) == 0 )
$template = "<$prefix value>";

while ( !is_false( $pos1 = strpos( $template, "<$prefix ", $offset ) ) )
{
$start = $pos1 + 2 + $prefixLength;
$pos2 = strpos( $template, ">", $start );
$length = $pos1 - $offset;
$parts[] = array( "str"=>substr( $template, $offset, $length ), "type"=>1 );
$length = $pos2-$start;
$parts[] = array( "str"=>trim(substr( $template, $start, $length )), "type"=>2 );

$offset = $pos2+1;  
}
$parts[] = array( "str"=>substr($template, $offset), "type"=>1 );
$ret = "";
$i = 1;
//                            
$myvalues = $this->getAllValues();
$props = array();
foreach ( $ids as $id )
{	
if ( $id == -9999 ) continue;
//                                                                                         
//                                                                                                    
//                                                                                             
//                                    
$key = $myvalues[$id]["key"];
$value = $id; 

if ( $i == 1 ) {
$props["value"] = $value; 
$props["key"] = $key;
}
$props["$i.value"] = $value;
$props["$i.key"] = $key;
$props["values"][] = $value;
$props["keys"][] = $key;
foreach ( $parts as $part )
{
switch ( $part["type"] )
{
//                         
case 1:
$ret .= $part["str"];
break;
//                   
case 2:
switch ( $part["str"] )
{
case "value":
$ret .= $value;
break;
case "nr":
$ret .= $i;				
break;
case "name":
case "key":
$ret .= $key;
break;
}
break;
}
}
$i++;
}

return array( "value"=>$ret, "props"=>$props );
}
}

?>
