<?php
GUIFactory::setMainGUI( "main" );
node_include('htmlform3');
node_class("listcomponent");
node_class("textcomponent");
node_class("itemlistcomponent");
node_class("sqldatasource");
node_class("arraydatasource");
node_class("commandaction");
node_class("labelcomponent");
node_class("resultsetformatter");
node_class("nodefactory");

/**
 *                      
 */
class IconFormatter extends ResultsetFormatter {
function format( $rs ) {
$obj = &NodeFactory::getStaticInstanceOf($rs['obj_type'], $rs['obj_id']);
if( $obj === null ) {
halt(7,"Unknown object obj_type:".$rs['obj_type']."/obj_id:".$rs['obj_id']);
}
return '<img src="' . $obj->getIcon() . '" alt=""> ';
}
}

/**
 *                
 */
class NameFormatter extends ResultsetFormatter {
function format( $rs ) {
$obj = &NodeFactory::getStaticInstanceOf($rs['obj_type'], $rs['obj_id']);
return $obj->getDisplayName();
}
}

/**
 *                                         
 */
class ObjTypeFormatter extends ResultsetFormatter {
function format( $rs ) {
$obj = &NodeFactory::getStaticInstanceOf($rs['obj_type'], $rs['obj_id']);
return $obj->getTypeName();
}
}


/**
 *                        
 */
class ReferrerFormatter extends ResultsetFormatter {
function format( $rs ) {
$obj = &NodeFactory::getStaticInstanceOf($rs['referrer_obj_type'], $rs['referrer_obj_id']);
$folderpath = $obj->getFolderPath();

return '<img src=' . $obj->getIcon() . ' border=0 /> ' . $folderpath . $obj->getDisplayName() . ' (' . $rs['referrer_obj_id'] . ')';
}
}

/**
 *                                    
 */
class CauseFormatter extends ResultsetFormatter {
function format($rs) {
$cause = "";
if ($rs["cause_obj_type"] && $rs["cause_obj_id"]) {
$causeObj = &NodeFactory::getStaticInstanceOf($rs["cause_obj_type"], $rs["cause_obj_id"]);
$cause = $causeObj->getDisplayName();
}
return $cause;
}
}

class DependencyAssFormatter extends ResultsetFormatter {
function format ($row ) {
$assistent = "ID: " . $row["obj_id"] . "<br/>";
switch ($row["obj_type"]) {
case T_PAGE:
case T_IMAGE:
case CT_FILE:
case T_FOLDER:
//                                                   
 $id = array($row["obj_id"]);
$folderpath = get_folder_structure($row["obj_type"], $id);
if ($folderpath[$row["obj_id"]]) {
$assistent .= i18n("Folder").":<br/>" . $folderpath[$row["obj_id"]] . "<br/>";
}
break;
}
return $assistent;
}
}

/**
 *                                       
 *                                         
 */
function &revalidatestatus( $id, $addedDependency=false ) {
$sql = "SELECT bundle_id FROM bundlecontainedobject WHERE id = ".sqlf_tl_num($id);
$rs = query( $sql );//            
 $bundle_id = $rs['arr'][0]['bundle_id'];
$bundle = &NodeFactory::getStaticInstanceOf(T_BUNDLE, $bundle_id);
$build = & $bundle->getLatestBuild();
//                                                                    
 if ($addedDependency) {
$build->setFieldValue('filename', '');
$build->save();
}
$build->revalidateStatus();
}

/**
 *                            
 */
function dep_add($id) {
$res = query("SELECT bundle_id, bundlebuild_id, obj_id, obj_type FROM bundlecontainedobject WHERE id = " . sqlf_tl_num($id));//            
 if ($res["num"] > 0) {
query("UPDATE bundlecontainedobject SET referrer_obj_id = 0, referrer_obj_type = 0 WHERE id = " . sqlf_tl_num($id));//            
 query(//            
"DELETE FROM bundlecontainedobject WHERE bundle_id = " . sqlf_tl_num($res['arr'][0]['bundle_id']) . 
" AND bundlebuild_id = ".sqlf_tl_num($res['arr'][0]['bundlebuild_id']) .
" AND obj_id = " . sqlf_tl_num($res['arr'][0]['obj_id']) . " AND obj_type = " . sqlf_tl_num($res['arr'][0]['obj_type']) . 
" AND id != " . sqlf_tl_num($id));
revalidatestatus( $id, true );
}
}

/**
 *                          
 */
function dep_accept($id) {
$res = query("SELECT bundle_id, bundlebuild_id, obj_id, obj_type FROM bundlecontainedobject WHERE id = " . sqlf_tl_num($id));//            
 if ($res["num"] > 0) {
query(//            
"UPDATE bundlecontainedobject SET accepted = 1 WHERE bundle_id = " . sqlf_tl_num($res['arr'][0]['bundle_id']) . 
" AND bundlebuild_id = ".sqlf_tl_num($res['arr'][0]['bundlebuild_id']) .
" AND obj_id = " . sqlf_tl_num($res['arr'][0]['obj_id']) . " AND obj_type = " . sqlf_tl_num($res['arr'][0]['obj_type']));
}
revalidatestatus( $id, false );
}

function retry_build($form, $bundle_id) {
global $REDO;
$bundle = &NodeFactory::getStaticInstanceOf(T_BUNDLE, $bundle_id);
$bb = &$bundle->getLatestBuild();
//                                                                    
 $bb->startExport();
$REDO = 1010;
}

/**
 *                                                                                       
 *                                                                    
 *                                                                  
 *                                  
 */
function defineButton($bundle_id) {
$bundle = &NodeFactory::getStaticInstanceOf(T_BUNDLE, $bundle_id);
$build = &$bundle->getLatestBuild();
$filename = $build->getFieldValue('filename');
$warningCount = $build->getWarningCount();
if ($filename && $warningCount == 0) {
return "continue";
}
if (!$filename) {
return "rebuild";
}
//                                             
 return "rebuild";
}

if((!perm($USER_ID, T_BUNDLE, '', 0)) || (!perm($USER_ID, T_BUNDLE_EXPORT_ELEMENT, $bundle_id, 0))) {
$ERROR = $DIC[2528];
return;
}

$form = new HtmlForm3("showbuildwarnings");
if ($form->isNew()) {
$form->setHeader(i18n("export_warnings"));

$depdescription = new LabelComponent(null, i18n('export_warnings_description'), true);

$form->addComponent('depdescription', $depdescription);

$group = 'referrer';

$bundle = &NodeFactory::getStaticInstanceOf(T_BUNDLE, $bundle_id);
$build = &$bundle->getLatestBuild();

$dsn = new SQLDatasource( 
'dependency_warnings',
"id,obj_type,obj_id,referrer_obj_id,referrer_obj_type, CONCAT(referrer_obj_type, '.', referrer_obj_id) referrer, cause_obj_type, cause_obj_id",
'bundlecontainedobject',
'referrer_obj_id != 0 AND referrer_obj_type != 0 AND accepted = 0 AND bundle_id = ' . sqlf_tl_num($bundle_id) . ' AND bundlebuild_id = ' . sqlf_tl_num($build->getID()), 
'', 
sqlf_field($group).", obj_type, obj_id"
);
$dsn->setDBHandle( $DB );
//                                              
 $dsn->setSearchable( false );
//                                                           
 if( perm ($USER_ID, T_BUNDLE_EXPORT_ELEMENT, $bundle_id, 1) || perm ($USER_ID, T_BUNDLE, '', 3) ) {
$dsn->addAction(new CommandAction($ICO_ADD, "add", i18n("add"), "dep_add"));
$dsn->addAction(new CommandAction($ICO_DELETE, "accept", i18n("ignore"), "dep_accept"));
}

$dsn->addColumn( 'icon', '', true, true );
$dsn->addColumn( 'name', i18n('Name'), true, true );
$dsn->addColumn( 'type', i18n('object type'), true, true );
$dsn->addColumn( 'cause', i18n('Cause'), true, true );

$dsn->addFormatter( 'icon', new IconFormatter() );
$dsn->addFormatter( 'name', new NameFormatter() );
$dsn->addFormatter( 'referrer', new ReferrerFormatter() );
$dsn->addFormatter( 'type', new ObjTypeFormatter() );
$dsn->addFormatter( 'cause', new CauseFormatter() );
$dsn->addAssFormatter(new DependencyAssFormatter());

$iList = new ItemList3("depwarn", $dsn );
$iList->sortCol = $group;
$iList->sortWay = 'ASC';
$iList->setGroupableColumns(array($group));
$iList->setNextSortWay($group);
$iList->setMaxListItems(50);

$list = new ItemListComponent(NULL, $iList);
$form->addComponent("list", $list);
$form->addButton("rebuild", new Button(i18n("Retry")), new SimpleFormAction("retry_build", $bundle_id), true);
$form->addComponent("bundle_id", new HiddenComponent($bundle_id));
} else {
//                                                                                                                                                               
 $iList = &$form->getComponent("list");
$ds = &$iList->getDatasource();
$ds->setDBHandle($DB);
$bundleIdComponent = &$form->getComponent("bundle_id");
$bundle_id = $bundleIdComponent->getValue();
$button = defineButton($bundle_id);
if ($button == "rebuild") {
$form->addButton("rebuild", new Button(i18n("Retry")), new SimpleFormAction("retry_build", $bundle_id), true);
} else if ($button == "continue") {
$form->addButton("rebuild", new Button(i18n("Done")), new RedoFormAction(1010), true);
}
}

load_menu(1012, T_BUNDLE_EXPORT_ELEMENT, $bundle_id, "<span class=\"addInfo\">" . i18n("export_warnings") . "</span>", 0, array('isimport' => false, 'bundle_id' => $bundle_id, 'frommenu' => '0'));

mysession_var_reg("BUNDLE_ID");
$BUNDLE_ID = $bundle_id;
?>
